Index: apps/app_queue.c
===================================================================
--- apps/app_queue.c	(revision 228826)
+++ apps/app_queue.c	(working copy)
@@ -405,6 +405,7 @@
 	unsigned int maskmemberstatus:1;
 	unsigned int realtime:1;
 	unsigned int found:1;
+	unsigned int relativeperiodicannounce:1;
 	int announcefrequency;              /*!< How often to announce their position */
 	int periodicannouncefrequency;      /*!< How often to play periodic announcement */
 	int roundingseconds;                /*!< How many seconds do we round to? */
@@ -1053,6 +1054,8 @@
 		}
 	} else if (!strcasecmp(param, "periodic-announce-frequency")) {
 		q->periodicannouncefrequency = atoi(val);
+	} else if (!strcasecmp(param, "relative-periodic-announce")) {
+		q->relativeperiodicannounce = ast_true(val);
 	} else if (!strcasecmp(param, "retry")) {
 		q->retry = atoi(val);
 		if (q->retry <= 0)
@@ -2141,7 +2144,10 @@
 		ast_moh_start(qe->chan, qe->moh, NULL);
 
 	/* update last_periodic_announce_time */
-	qe->last_periodic_announce_time = now;
+	if (qe->parent->relativeperiodicannounce)
+		time(&qe->last_periodic_announce_time);
+	else
+		qe->last_periodic_announce_time = now;
 
 	/* Update the current periodic announcement to the next announcement */
 	qe->last_periodic_announce_sound++;
Index: configs/queues.conf.sample
===================================================================
--- configs/queues.conf.sample	(revision 228826)
+++ configs/queues.conf.sample	(working copy)
@@ -139,6 +139,12 @@
 ;
 ;periodic-announce-frequency=60
 ;
+; If set to yes, the periodic announcment frequency will be timed from the end
+; of each announcment rather than from the start of each announcment.  This
+; defaults to off.
+;
+;relative-periodic-announce=yes
+;
 ; Should we include estimated hold time in position announcements?
 ; Either yes, no, or only once.
 ; Hold time will be announced as the estimated time, 
